#include <iostream>
#include <string>
#include <map>
#include <list>
#include <sstream>
#include <fstream>

#include <cstdlib>
#include <sys/types.h> 
#include <unistd.h>
 
using namespace std;

int main(int argc, char **argv)
{
	string ldd="/usr/bin/ldd ";
	ostringstream tmpfilename;
	tmpfilename << argv[0] << getpid() << ".tmp";
	map<string,int> occurencemap;
	
	for(int k=1; k<argc; k++)
	{
		string command = ldd + string(argv[k]) + string(" > ").append(tmpfilename.str());
		cout << "execute " << command << endl;
		if(system(command.c_str()) != 0)
		{
			cerr << "An error occured when calling " << command << endl;
			return -1;
		}
		else
		{
			string lib;
			char linebuffer[255];
			ifstream inputfile(tmpfilename.str().c_str());
			while(!inputfile.eof())
			{
				inputfile.getline(linebuffer,255);
				istringstream parsestream(linebuffer);
				parsestream >> lib;
				occurencemap[lib]++;
			}
			unlink(tmpfilename.str().c_str());
		} 
	}
	// evaluate map
	int programs=argc-1;
	for(map<string,int>::const_iterator it=occurencemap.begin(); it != occurencemap.end(); it++)
	{
		if(it->second == programs) cout << "common lib: " << it->first << endl;
	}
	return 0;
}
